/* DCINST.PH */
/* Y.L. Noyelle, Supelec, France 1998 */

#ifndef DCINST_PH
#define DCINST_PH

#include "dc.th"

/*~ Private */
typedef enum {PlainBlk, InsideSw = 1, InsideIf = InsideSw<<1} Tenvir;

typedef struct _tMngIU TmngIU;
/*~ Public */

typedef struct {
  TmngIU *oldPHMIU;
  TnstLvl oldInsideIF, savOCL;
  Tenvir oldEnvir;
} TsavInfoIU;

/* Functions profiles */
extern void addNotInitVarList(TsemanElt *, bool);
extern void errInit(TsemanElt *, TlineNb, Tstring, bool);
extern void initInst(void);
extern void mngIFInitlzUsed(TsavInfoIU *, const TsavInfoIU *);
extern void storeInitlz(TsemanElt *);

/* External objects */
extern TnstLvl condStmtLvl;  /* zero as long as control flow has to go
								through here. */
extern uint ctrCE;   /* number of caseElt currently allocated */
extern uint ctrIU;   /* number of mngtInitlzUsed blocks */
extern uint ctrNI;   /* number of notInitVar blocks */
extern TpTypeElt curFctRetType;
extern TnstLvl initialLoopCondLvl;
extern TnstLvl insideIF;
extern bool longjmpTaken;
extern uint loopLvl;
extern TnstLvl setjmpBlkLvl;
extern bool setjmpSeen;

#endif /* ifndef DCINST_PH */
/* End DCINST.PH */
